unit UCaricaPlayList;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls ,UOpzioni;

type
  TFormCarica = class(TForm)
    Label1: TLabel;
    OK: TButton;
    Annulla: TButton;
    ListBox1: TListBox;
    Image1: TImage;
    procedure AnnullaClick(Sender: TObject);
    procedure OKClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure ListBox1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure ListBox1KeyPress(Sender: TObject; var Key: Char);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    FileLista : String;
    Lista,
    ListaConIPerscorsi : TStringList;
    Dati : TList;
  public
    procedure ElencaPlayList(Listbox : TListBox);
  end;

var
  FormCarica: TFormCarica;

implementation

uses MainMp3;

{$R *.dfm}

procedure TFormCarica.AnnullaClick(Sender: TObject);
begin
 Close;
end;

procedure TFormCarica.ElencaPlayList(Listbox : TListBox);
begin
  Lista.Clear;
  if DirectoryExists(CartellaPlay) then
   begin
    CercaFilesCercaFilesConINomiSenzaEst(Lista ,CartellaPlay ,'*.dat');
    CercaFiles(ListaConIPerscorsi ,CartellaPlay ,'*.dat');
    Listbox.Items.Assign(Lista);
   end;
end;

procedure TFormCarica.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  if MessageBox(Handle ,'Sei sicuro di voler annullare la procedura?' ,'Annullare?' ,MB_ICONQUESTION or MB_YESNO ) = ID_YES then
  begin
   Image1.Picture.LoadFromFile(AppIco);
   MainForm.Attiva;
  end;
end;

procedure TFormCarica.FormCreate(Sender: TObject);
begin
 Lista := TStringList.Create;
 ListaConIPerscorsi := TStringList.Create;
end;

procedure TFormCarica.FormDestroy(Sender: TObject);
begin
 ListaConIPerscorsi.Free;
 Lista.Free;
end;

procedure TFormCarica.FormKeyPress(Sender: TObject; var Key: Char);
begin
 if Ord(Key) = 27 then
  AnnullaClick(Sender);
end;

procedure TFormCarica.FormShow(Sender: TObject);
begin
 ElencaPlayList(ListBox1);
end;

procedure TFormCarica.ListBox1Click(Sender: TObject);
begin
  if Listbox1.ItemIndex > -1 then
   begin
    FileLista := ListaConIPerscorsi.Strings[ListBox1.ItemIndex];
    LeggiFileLista(FileLista ,Dati);
    Image1.Picture.LoadFromFile(Dati.FileImmagine);
   end;
end;

procedure TFormCarica.ListBox1KeyPress(Sender: TObject; var Key: Char);
begin
  if (Ord(Key) = 99) or (Ord(Key) = 67) then
   begin

     if CancellaFile(CartellaPlay + '/' + Dati.Nome + '.dat') then
      begin
       ElencaPlayList(ListBox1);
      end;
   end
  else
   if Ord(Key) = 13 then
    OKClick(Sender)
  else
   FormKeyPress(Sender ,Key);
end;

procedure TFormCarica.OKClick(Sender: TObject);
begin
 if FileExists(FileLista) then
  begin
    MainForm.CaricaPlayList(FileLista);
  end;
  Hide;
  Image1.Picture.LoadFromFile(AppIco);
  MainForm.Attiva;
end;

end.
