{
                Unit scritta da Saladino

  Author      : Saladino (saladino_93hotmail.it)
  Created     : August 30 2010 (Lazarus)
  Version     : 1.0
  Classes     : TPlayList;
  License     : GNU

  Uso le MCI di windows per la riproduzione dei files.
  La funzione principale e' :
   c //Per lo Unicode

}

unit UPlayList;


interface

uses
  Classes, SysUtils ,windows;


type
  MCIDEVICEID = UINT;
  MCIERROR = DWORD;

  MCI_OPEN_PARMS = record
    dwCallback: DWORD;
    wDeviceID: MCIDEVICEID;
    lpstrDeviceType: PAnsiChar;
    lpstrElementName: PAnsiChar;
    lpstrAlias: PAnsiChar;
  end;

 PMCI_OPEN_PARMS = ^MCI_OPEN_PARMS;

  { TPlayList }

  TPlayList = class(TObject)
  private
    PItems    : array of String;
    Last      : String;
    Leng      : Integer; //lunghezza items
    PCurr     : String;  //Nome del file che deve essere riprodotto
    PErr      : MCIERROR;
    PNames    : TStringList;
    POpen     : Boolean;
    PComm     : PAnsiChar;
    Lng       : Cardinal; //lunghezza file
    Playin,
    Pausin,
    Stopp     : Boolean;
    PLastPos  : Cardinal;
    PVolume   : Word;
    PFinish   : TNotifyEvent;
    PLung     : Integer; //lunghezza file
    POnChange : TNotifyEvent;
    FOnClose  : TNotifyEvent;
    function GetCurr: String;
    function GetCurrName: String;
    function GetItem(I : Integer): String;
    procedure SetCurr(const AValue: String);
    procedure SetItem(I : Integer; const AValue: String);
    function  CalcLeng : Cardinal;
    procedure SetPos(const AValue: Integer);
    procedure SetVol(Val : Word);
    function GetPos : Integer;
    procedure Change;
    procedure SetOnClose(const Value: TNotifyEvent);
  public
    constructor Create;
    property  LungItems : Integer read Leng; //degli items
    property  Item [I : Integer] : String read GetItem write SetItem;
    property  Names : TStringList read PNames;
    property  CurrItem : String read GetCurr write SetCurr;
    property  CurrName : String read GetCurrName;
    property  LastItem : String read Last;
    property  OnChange : TNotifyEvent read POnChange write POnChange;
    procedure Add(S : String);
    procedure Clear;
    procedure Delete(I : Integer);
    function  Presente (S : String) : Boolean;
    function  ItemIndex : Integer; 
    ////////////////////
    property  Playing : Boolean read Playin;
    property  Pausing : Boolean read Pausin;
    property  Lunghezza : Cardinal read CalcLeng;
    property  Opened : Boolean read POpen;
    property  Volume : Word read PVolume write SetVol;
    property  Posizione : Integer read GetPos write SetPos;
    property  OnItemFinish : TNotifyEvent read PFinish write PFinish;
    property  OnClose : TNotifyEvent read FOnClose write SetOnClose;
    function  Open : Boolean; 
    function  Close : Boolean;
    function  Play(Position : Cardinal = 0) : Boolean;
    function  Resume : Boolean;
    function  Pause : Boolean;
    function  Stop : Boolean;
    function  Next : Boolean;
    function  Prev : Boolean;
    function  EnableSound : Boolean;
    function  DisableSound : Boolean;
    destructor Destroy; override;
   end;

const
 MCI_ALL_DEVICE_ID = -1;


{ MCI command message identifiers }
const
  {$EXTERNALSYM MCI_OPEN}
  MCI_OPEN       = $0803;
  {$EXTERNALSYM MCI_CLOSE}
  MCI_CLOSE      = $0804;
  {$EXTERNALSYM MCI_ESCAPE}
  MCI_ESCAPE     = $0805;
  {$EXTERNALSYM MCI_PLAY}
  MCI_PLAY       = $0806;
  {$EXTERNALSYM MCI_SEEK}
  MCI_SEEK       = $0807;
  {$EXTERNALSYM MCI_STOP}
  MCI_STOP       = $0808;
  {$EXTERNALSYM MCI_PAUSE}
  MCI_PAUSE      = $0809;
  {$EXTERNALSYM MCI_INFO}
  MCI_INFO       = $080A;
  {$EXTERNALSYM MCI_GETDEVCAPS}
  MCI_GETDEVCAPS = $080B;
  {$EXTERNALSYM MCI_SPIN}
  MCI_SPIN       = $080C;
  {$EXTERNALSYM MCI_SET}
  MCI_SET        = $080D;
  {$EXTERNALSYM MCI_STEP}
  MCI_STEP       = $080E;
  {$EXTERNALSYM MCI_RECORD}
  MCI_RECORD     = $080F;
  {$EXTERNALSYM MCI_SYSINFO}
  MCI_SYSINFO    = $0810;
  {$EXTERNALSYM MCI_BREAK}
  MCI_BREAK      = $0811;
  MCI_SOUND      = $0812;
  {$EXTERNALSYM MCI_SAVE}
  MCI_SAVE       = $0813;
  {$EXTERNALSYM MCI_STATUS}
  MCI_STATUS     = $0814;
  {$EXTERNALSYM MCI_CUE}
  MCI_CUE        = $0830;
  {$EXTERNALSYM MCI_REALIZE}
  MCI_REALIZE    = $0840;
  {$EXTERNALSYM MCI_WINDOW}
  MCI_WINDOW     = $0841;
  {$EXTERNALSYM MCI_PUT}
  MCI_PUT        = $0842;
  {$EXTERNALSYM MCI_WHERE}
  MCI_WHERE      = $0843;
  {$EXTERNALSYM MCI_FREEZE}
  MCI_FREEZE     = $0844;
  {$EXTERNALSYM MCI_UNFREEZE}
  MCI_UNFREEZE   = $0845;
  {$EXTERNALSYM MCI_LOAD}
  MCI_LOAD       = $0850;
  {$EXTERNALSYM MCI_CUT}
  MCI_CUT        = $0851;
  {$EXTERNALSYM MCI_COPY}
  MCI_COPY       = $0852;
  {$EXTERNALSYM MCI_PASTE}
  MCI_PASTE      = $0853;
  {$EXTERNALSYM MCI_UPDATE}
  MCI_UPDATE     = $0854;
  {$EXTERNALSYM MCI_RESUME}
  MCI_RESUME     = $0855;
  {$EXTERNALSYM MCI_DELETE}
  MCI_DELETE     = $0856;

function mciSendCommand(Par1 : MCIDEVICEID; Par2 : UINT; Par3 : DWORD; Par4 : DWORD) : MCIERROR; stdcall; external 'winmm.dll' name 'mciSendCommandA';
function mciSendString(Par1 : LPCSTR; Par2 : LPCSTR; Par3 : UINT; Par4 : HWND) : MCIERROR; stdcall;  external 'winmm.dll' name 'mciSendStringA';

function mciSendStringW(Par1 : LPWSTR; Par2 : LPWSTR; Par3 : UINT; Par4 : HWND) : MCIERROR; stdcall;  external 'winmm.dll' name 'mciSendStringW';
function SendMessage(hWnd:HWND; Msg:UINT; wParam:WPARAM; lParam:LPARAM):LRESULT; external 'user32' name 'SendMessageA';

function ExtractFileType(var S : String) : String;

implementation


function ExtractFileType(var S : String) : String;
Var
 P : Integer;
 Temp : String;
begin
 Temp := S;
 P := 0;
 P := Pos('.' ,Temp);
 Delete(Temp ,1 ,P - 1);
 Result := Temp;
end;


{ TPlayList }

constructor TPlayList.Create;
begin
  inherited Create;
  Playin := False;
  Pausin := False;
  Stopp  := False;
  POpen  := False;
  PLastPos := 0;
  Leng := -1;
  PNames := TStringList.Create;
end;

function TPlayList.GetItem(I : Integer) : String;
begin
 if (I <= Length(PItems)) and (I > -1) then
   Result := PItems[I];
end;

function TPlayList.GetCurr : String;
begin
 Result := PCurr;
end;

function TPlayList.GetCurrName : String;
begin
 Result := ExtractFileName(PCurr);
end;

procedure TPlayList.SetCurr(const AValue : String);
begin
 PCurr := AValue;
end;

procedure TPlayList.SetItem(I : Integer; const AValue: String);
begin
  if (I > -1) and (I <= Length(PItems)) then
   begin
     PItems[I] := AValue;
     if Assigned(POnChange) then
      POnChange(Self);
   end;
end;

 
procedure TPlayList.SetOnClose(const Value: TNotifyEvent);
begin
  FOnClose := Value;
end;

procedure TPlayList.Add(S : String);
begin
  Change;
  Leng := Leng + 1;
  SetLength(PItems ,Leng + 1);
  PItems[Leng] := S;
  Last := S;   
  PNames.Add(ExtractFileName(S));
end;

procedure TPlayList.Clear;
begin
  Leng := -1;
  if PItems <> Nil then  
   PItems := nil;
end;

procedure TPlayList.Delete(I : Integer);
Var
 Count : Integer;
begin
  if (I <= Leng) and (I >= 0) then
   begin
     for Count := I to Leng - 2 do
      begin
       PItems[Count + 1] := PItems[Count];
      end;
     Dec(Leng);
     SetLength(PItems ,Leng);
   end;
end;

//da migliorare
function TPlayList.Presente(S: String): Boolean;
Var
 I : Integer;
 Continua : Word;
begin
  I := -1;
  Continua := 1;
  if Leng > -1 then
   begin
    while ((Continua <> 0) and (I <= Leng - 1)) do
     begin
      I := I + 1;
      Continua := AnsiCompareStr(S ,PItems[I]);
     end;
   end;
  Result := Continua = 0;
end;

function TPlayList.Open : Boolean;
begin
 if POpen then
  Close;
 PComm := PAnsiChar('set FileAudio time format ms');
 PErr := mciSendString(PComm ,nil ,0 ,0);
 if PErr = 0 then
  begin
   PComm := PAnsiChar('set FileAudio seek exactly on');
   PErr := mciSendString(PComm ,nil ,0 ,0);
   if PErr <> 0 then
     POpen := False;
  end;
 PComm := PAnsiChar('open "' + PCurr + '" type mpegvideo alias  FileAudio');
 PErr := mciSendString(PComm ,nil ,0 ,0);
 if PErr = 0 then
  begin
   POpen :=True;
   PLung := CalcLeng;
  end;
 Result := POpen;
end;

function TPlayList.Close : Boolean;
begin
 Result := False;
 if POpen then
  begin
   if Assigned(FOnClose) then
      FOnClose(Self);
   PComm := 'close  FileAudio';
   PErr := mciSendString(PComm ,nil ,0 ,0);
   if PErr = 0 then
    begin
     Pausin := False;
     Playin := False;
     Stopp  := False;
     POpen := False;
     Result := True;
    end;
  end;
end;

function TPlayList.Play(Position : Cardinal = 0) : boolean;
begin
 Result := False; 
 if POpen then
  begin
   PComm := PAnsiChar('play  FileAudio from ' + IntToStr(Position));
   PErr := mciSendString(PComm ,nil ,0 ,0);
   if PErr = 0 then
    begin
     Pausin := False;
     Stopp  := False;
     Playin := True;
    end;
   Result := Playin;
  end;
end;

function TPlayList.Resume: Boolean;
begin
 Result := False;
 if POpen then
 begin
  PComm := PAnsiChar('resume  FileAudio');
  PErr := mciSendString(PComm ,nil ,0 ,0);
  if PErr = 0 then
   begin
    Pausin := False;
    Stopp  := False;
    Playin := True;
   end;
  Result := Playin;
 end;
end;

function TPlayList.Pause: Boolean;
begin
 Result := False;
if POpen then
 begin
  PComm := 'pause FileAudio';
  PErr := mciSendString(PComm ,nil ,0 ,0);
  if PErr = 0 then
   begin
    Stopp := False;
    Playin := False;
    Pausin := True;
    Result := True;
   end;
 end;
end;

function TPlayList.Stop: Boolean;
begin
Result := False;
if POpen then
 begin
  PComm := 'stop FileAudio';
  PErr := mciSendString(PComm ,Nil ,0 ,0);
  if PErr = 0 then
   Stopp := True;
  Result := False;
  if Stopp then
   begin
    Pausin := False;
    Playin := False;
    Result := True;
   end;
 end;
end;

//Da ricontrollare
function TPlayList.Next : Boolean;
Var
 Ind  : Integer;
 Pl : Boolean;
begin
 Ind := ItemIndex;
 if ItemIndex < LungItems then
   begin
     Pl := Playin;
     if POpen then
       Close;
     CurrItem := Item[Ind + 1];
     MessageboxA(0 ,PChar(CurrItem) ,PAnsiChar('') ,0);
   end;
 Result := False;
end;

function TPlayList.Prev: Boolean;
begin
 Result := False;
end;

function TPlayList.GetPos: Integer;
Var
  Pos : Integer;
  Stringa : PAnsiChar;
begin
  try
   Result := -1;
   Stringa := Nil;
   PComm := PAnsiChar('status FileAudio position');
   GetMem(Stringa ,128);
   mciSendString(PComm ,Stringa ,128 ,0);
   if PErr = 0 then
    begin
     Pos := StrToInt(Stringa);
     Result := Pos;
    end
   else
    begin
     Pos := 0;
    end;
   if Pos >= PLung then
    if Assigned(PFinish) then
     begin
      PFinish(Self);
     end;
  finally
    Freemem(Stringa ,128);
    Stringa := Nil;
  end;
end;

function TPlayList.ItemIndex: Integer;
Var
 Temp : Integer;
begin
  Result := 0;
  Temp := 0;
  if LungItems > 0  then  
   while True do
    begin
      if PItems[Temp] = PCurr then
        Break;
      Temp := Temp + 1;
    end;
  Result := Temp;
end;

procedure TPlayList.SetVol(Val: Word);
begin
 if (Val <= 1000) and (Val >= 0) and (POpen = True) then
  begin
   PComm := PAnsiChar('setaudio FileAudio volume to ' + IntToStr(Val));
   PErr := mciSendString(PComm  ,Nil ,0 ,0);
   if PErr = 0 then
    PVolume := Val;
  end;
end;


procedure TPlayList.Change;
begin
  if Assigned(POnChange) then
   POnChange(Self);
end;

{
procedure TPlayList.Mute;
begin
 if PMuto then
  begin
   PComm := PChar('setaudio FileAudio on');
  end
 else
   PComm := PChar('setaudio FileAudio off');
 PErr := mciSendStringW(PComm ,nil ,0 ,0);
 if PErr = 0 then
   PMuto := not PMuto; //bella questa parte
end;
}

function TPlayList.EnableSound : Boolean;
begin
  Result := False;
  PComm := PAnsiChar('setaudio FileAudio on');
  PErr := mciSendString(PComm ,nil ,0 ,0);
  if PErr = 0 then
   Result := True;
end;

function TPlayList.DisableSound : Boolean;
begin
 Result := False;
 PComm := PAnsiChar('setaudio FileAudio off');
 PErr := mciSendString(PComm ,nil ,0 ,0);
 if PErr = 0 then
   Result := True;
end;

function TPlayList.CalcLeng : Cardinal;
Var
 Stringa : PAnsiChar;
 S       : String;
begin
 try
  Stringa := Nil;
  Getmem(Stringa ,128);
  PComm := PAnsiChar('status FileAudio length');
  mciSendString(PComm ,Stringa ,128 ,0);
  S := Stringa;
  Lng := StrToInt(S);
  Result := Lng;
 finally
  Freemem(Stringa ,128);
  Stringa := Nil;
 end;
end;


procedure TPlayList.SetPos(const AValue: Integer);
begin
 if POpen then
  begin
   PComm := PAnsiChar('seek FileAudio to' + IntToStr(AValue));
   mciSendString(PComm  ,Nil ,0 ,0);
   if Playin then
    begin
     PComm := PAnsiChar('play FileAudio from ' + IntToStr(PLastPos));
     mciSendString(PComm  ,Nil ,0 ,0);
    end;
  end;
end;


{
function ThreadDaFare(P : Pointer) : Longint; stdcall;
begin
 Well := True;
 Result := 0;
end;

procedure Procedura(Procedura : TProcedure);
Var
 Thread,Th : THANDLE;
 Err : Longint;
begin
 if Assigned(Procedura) then
   Procedura;
 Thread := CreateThread(nil ,0 ,@ThreadDaFare ,nil ,0 ,Th);
 repeat
  GetExitCodeThread(Thread ,@Err);
 until Well or (Err <> STILL_ACTIVE);
end;      }


destructor TPlayList.Destroy;
begin
  PFinish := nil;
  PNames.Free;
  inherited Destroy;
end;


end.

